Index: /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2408)
@@ -23,5 +23,4 @@
   USE climb_wind_mod,      ONLY : climb_wind_down, climb_wind_up
   USE coef_diff_turb_mod,  ONLY : coef_diff_turb
-  USE control_mod
 
 
@@ -49,7 +48,7 @@
 
     USE indice_sol_mod
+    USE print_control_mod, ONLY: lunout
 
     INCLUDE "dimsoil.h"
-    INCLUDE "iniprint.h"
  
 ! Input variables
@@ -73,14 +72,14 @@
 !****************************************************************************************    
     ALLOCATE(fder(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
 
     ALLOCATE(snow(klon,nbsrf), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
 
     ALLOCATE(qsurf(klon,nbsrf), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
 
     ALLOCATE(ftsoil(klon,nsoilmx,nbsrf), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
 
 
@@ -100,5 +99,5 @@
       WRITE(lunout,*)"or on doit commencer par les surfaces continentales"
       abort_message="voir ci-dessus"
-      CALL abort_gcm(modname,abort_message,1)
+      CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -109,5 +108,5 @@
       WRITE(lunout,*)' or is_oce = ',is_oce, '> is_sic = ',is_sic
       abort_message='voir ci-dessus'
-      CALL abort_gcm(modname,abort_message,1)
+      CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -118,5 +117,5 @@
       WRITE(lunout,*)' or is_lic = ',is_lic, '> is_sic = ',is_sic
       abort_message='voir ci-dessus'
-      CALL abort_gcm(modname,abort_message,1)
+      CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -130,5 +129,5 @@
        WRITE(lunout,*)'Option couplage pour l''ocean = ', type_ocean
        abort_message='option pour l''ocean non valable'
-       CALL abort_gcm(modname,abort_message,1)
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -261,4 +260,7 @@
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
     USE indice_sol_mod
+    USE time_phylmdz_mod, ONLY: day_ini,annee_ref,itau_phy
+    USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
+    USE print_control_mod, ONLY: prt_level,lunout
 
     IMPLICIT NONE
@@ -266,11 +268,8 @@
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
-    INCLUDE "iniprint.h"
     INCLUDE "YOETHF.h"
     INCLUDE "FCTTRE.h"
     INCLUDE "clesphys.h"
     INCLUDE "compbl.h"
-    INCLUDE "dimensions.h"
-    INCLUDE "temps.h"
     INCLUDE "flux_arp.h"
 !****************************************************************************************
@@ -733,9 +732,9 @@
 
 ! For debugging with IOIPSL
-    INTEGER, DIMENSION(iim*(jjm+1))    :: ndexbg
+    INTEGER, DIMENSION(nbp_lon*nbp_lat)    :: ndexbg
     REAL                               :: zjulian
     REAL, DIMENSION(klon)              :: tabindx
-    REAL, DIMENSION(iim,jjm+1)         :: zx_lon, zx_lat
-    REAL, DIMENSION(iim,jjm+1)         :: debugtab
+    REAL, DIMENSION(nbp_lon,nbp_lat)         :: zx_lon, zx_lat
+    REAL, DIMENSION(nbp_lon,nbp_lat)         :: debugtab
 
 
@@ -794,12 +793,12 @@
           idayref = day_ini
           CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
-          CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,zx_lon)
-          DO i = 1, iim
+          CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlon,zx_lon)
+          DO i = 1, nbp_lon
              zx_lon(i,1) = rlon(i+1)
-             zx_lon(i,jjm+1) = rlon(i+1)
+             zx_lon(i,nbp_lat) = rlon(i+1)
           ENDDO
-          CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,zx_lat)
-          CALL histbeg("sous_index", iim,zx_lon(:,1),jjm+1,zx_lat(1,:), &
-               1,iim,1,jjm+1, &
+          CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,rlat,zx_lat)
+          CALL histbeg("sous_index",nbp_lon,zx_lon(:,1),nbp_lat,zx_lat(1,:), &
+               1,nbp_lon,1,nbp_lat, &
                itau_phy,zjulian,dtime,nhoridbg,nidbg) 
           ! no vertical axis
@@ -809,6 +808,6 @@
           cl_surf(4)='sic'
           DO nsrf=1,nbsrf
-             CALL histdef(nidbg, cl_surf(nsrf),cl_surf(nsrf), "-",iim, &
-                  jjm+1,nhoridbg, 1, 1, 1, -99, 32, "inst", dtime,dtime) 
+             CALL histdef(nidbg, cl_surf(nsrf),cl_surf(nsrf), "-",nbp_lon, &
+                  nbp_lat,nhoridbg, 1, 1, 1, -99, 32, "inst", dtime,dtime) 
           END DO
 
@@ -1144,5 +1143,5 @@
           ndexbg(:) = 0
           CALL gath2cpl(tabindx,debugtab,knon,ni)
-          CALL histwrite(nidbg,cl_surf(nsrf),itap,debugtab,iim*(jjm+1), ndexbg)
+          CALL histwrite(nidbg,cl_surf(nsrf),itap,debugtab,nbp_lon*nbp_lat, ndexbg)
        ENDIF
        
@@ -1318,5 +1317,5 @@
 !     *sqrt(yu(i,1)*yu(i,1)+yv(i,1)*yv(i,1)))
        ycdragm(i) = ust*ust/(1.+vent)/vent
-       print *,'ycdragm ust yu yv apres=',ycdragm(i),ust,yu(i,1),yv(i,1)
+!      print *,'ycdragm ust yu yv apres=',ycdragm(i),ust,yu(i,1),yv(i,1)
       ENDDO
      ENDIF
@@ -1343,8 +1342,8 @@
         IF (ok_prescr_ust) then
          DO i = 1, knon
-          print *,'ycdragm_x avant=',ycdragm_x(i)
+!         print *,'ycdragm_x avant=',ycdragm_x(i)
           vent= sqrt(yu_x(i,1)*yu_x(i,1)+yv_x(i,1)*yv_x(i,1))
           ycdragm_x(i) = ust*ust/(1.+vent)/vent
-          print *,'ycdragm_x ust yu yv apres=',ycdragm_x(i),ust,yu_x(i,1),yv_x(i,1)
+!         print *,'ycdragm_x ust yu yv apres=',ycdragm_x(i),ust,yu_x(i,1),yv_x(i,1)
          ENDDO
         ENDIF
@@ -1367,11 +1366,11 @@
             ycdragm_w, ycdragh_w, zri1_w, pref_w )
 
-! --- special Dice. JYG+MPL 25112013
+! --- special Dice. JYG+MPL 25112013 puis BOMEX
         IF (ok_prescr_ust) then
          DO i = 1, knon
-          print *,'ycdragm_w avant=',ycdragm_w(i)
+!         print *,'ycdragm_w avant=',ycdragm_w(i)
           vent= sqrt(yu_w(i,1)*yu_w(i,1)+yv_w(i,1)*yv_w(i,1))
           ycdragm_w(i) = ust*ust/(1.+vent)/vent
-          print *,'ycdragm_w ust yu yv apres=',ycdragm_w(i),ust,yu_w(i,1),yv_w(i,1)
+!         print *,'ycdragm_w ust yu yv apres=',ycdragm_w(i),ust,yu_w(i,1),yv_w(i,1)
          ENDDO
         ENDIF
@@ -1747,6 +1746,7 @@
                y_flux_u1, y_flux_v1 )
                
-! Special DICE MPL 05082013
+! Special DICE MPL 05082013 puis BOMEX
        IF (ok_prescr_ust) THEN
+          do j=1,knon
 !         ysnow(:)=0.
 !         yqsol(:)=0.
@@ -1761,6 +1761,7 @@
 !         y_dflux_t(:)=0.
 !         y_dflux_q(:)=0.
-          y_flux_u1(:)=ycdragm(:)*(1.+sqrt(yu(:,1)*yu(:,1)+yv(:,1)*yv(:,1)))*yu(:,1)*ypplay(:,1)/RD/yt(:,1)
-          y_flux_v1(:)=ycdragm(:)*(1.+sqrt(yu(:,1)*yu(:,1)+yv(:,1)*yv(:,1)))*yv(:,1)*ypplay(:,1)/RD/yt(:,1)
+          y_flux_u1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yu(j,1)*ypplay(j,1)/RD/yt(j,1)
+          y_flux_v1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yv(j,1)*ypplay(j,1)/RD/yt(j,1)
+          enddo
       ENDIF
 
@@ -1797,4 +1798,11 @@
           END DO
           ! Martin
+! Special DICE MPL 05082013 puis BOMEX MPL 20150410
+       IF (ok_prescr_ust) THEN
+          DO j=1,knon
+          y_flux_u1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yu(j,1)*ypplay(j,1)/RD/yt(j,1)
+          y_flux_v1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yv(j,1)*ypplay(j,1)/RD/yt(j,1)
+          ENDDO
+      ENDIF
           
        CASE(is_oce)
@@ -1825,4 +1833,11 @@
           print *,'arg de surf_ocean: ytsurf_new ',ytsurf_new
        ENDIF
+! Special DICE MPL 05082013 puis BOMEX MPL 20150410
+       IF (ok_prescr_ust) THEN
+          DO j=1,knon
+          y_flux_u1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yu(j,1)*ypplay(j,1)/RD/yt(j,1)
+          y_flux_v1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yv(j,1)*ypplay(j,1)/RD/yt(j,1)
+          ENDDO
+      ENDIF
           
        CASE(is_sic)
@@ -1844,9 +1859,16 @@
                y_flux_u1, y_flux_v1)
           
+! Special DICE MPL 05082013 puis BOMEX MPL 20150410
+       IF (ok_prescr_ust) THEN
+          DO j=1,knon
+          y_flux_u1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yu(j,1)*ypplay(j,1)/RD/yt(j,1)
+          y_flux_v1(j)=ycdragm(j)*(1.+sqrt(yu(j,1)*yu(j,1)+yv(j,1)*yv(j,1)))*yv(j,1)*ypplay(j,1)/RD/yt(j,1)
+          ENDDO
+      ENDIF
 
        CASE DEFAULT
           WRITE(lunout,*) 'Surface index = ', nsrf
           abort_message = 'Surface index not valid'
-          CALL abort_gcm(modname,abort_message,1)
+          CALL abort_physic(modname,abort_message,1)
        END SELECT
 
@@ -1886,6 +1908,8 @@
 !
           IF (iflag_split .eq.0) THEN
-             Kech_h(:) = ycdragh(:) * (1.0+SQRT(yu(:,1)**2+yv(:,1)**2)) * &
-                  ypplay(:,1)/(RD*yt(:,1))
+             do j=1,knon
+             Kech_h(j) = ycdragh(j) * (1.0+SQRT(yu(j,1)**2+yv(j,1)**2)) * &
+                  ypplay(j,1)/(RD*yt(j,1))
+             enddo
           ENDIF ! (iflag_split .eq.0)
 
@@ -1895,9 +1919,13 @@
           ENDDO
 
-          y_d_ts(:) = ytsurf_new(:) - yts(:) 
+          do j=1,knon
+          y_d_ts(j) = ytsurf_new(j) - yts(j) 
+          enddo
 
         ELSE ! (ok_flux_surf)
-          y_flux_t1(:) =  yfluxsens(:)
-          y_flux_q1(:) = -yevap(:)
+          do j=1,knon
+          y_flux_t1(j) =  yfluxsens(j)
+          y_flux_q1(j) = -yevap(j)
+          enddo
         ENDIF
 
@@ -3060,5 +3088,5 @@
                 ! Security abort. This option has never been tested. To test, comment the following line.
 !                abort_message='The fraction of the continents have changed!'
-!                CALL abort_gcm(modname,abort_message,1)
+!                CALL abort_physic(modname,abort_message,1)
                 nfois(nsrf) = nfois(nsrf) + 1
              END IF
Index: /LMDZ5/branches/testing/libf/phylmd/perturb_radlwsw.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/perturb_radlwsw.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/perturb_radlwsw.F90	(revision 2408)
@@ -0,0 +1,27 @@
+      SUBROUTINE perturb_radlwsw(zxtsol,iflag_radia)
+!
+!Case-specific radiative setup
+!
+      use dimphy
+      IMPLICIT none
+      INCLUDE "flux_arp.h"     
+!
+! Arguments :
+!------------
+      REAL,DIMENSION(klon), INTENT(INOUT) :: zxtsol
+      INTEGER, INTENT(IN)                 :: iflag_radia
+!
+!======================================================================
+!
+      IF (iflag_radia == 2) THEN
+!
+! Iflag_radia = 2 : DICE case : 
+!               on force zxtsol=tg pour le rayonnement (MPL 20130806)
+!Sonia : Cas dice lmdz1d force en flux : on impose Tg pour imposer le LWUP
+!
+        zxtsol(:) =  tg
+      ENDIF
+!
+      RETURN
+      END
+
Index: /LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2408)
@@ -5,5 +5,5 @@
 CONTAINS
 
-  SUBROUTINE iniaqua(nlon, latfi, lonfi, iflag_phys)
+  SUBROUTINE iniaqua(nlon, iflag_phys)
 
     ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -19,27 +19,24 @@
     ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-    USE comgeomphy, ONLY: rlatd, rlond
     USE dimphy, ONLY: klon
+    USE geometry_mod, ONLY : latitude
     USE surface_data, ONLY: type_ocean, ok_veget
     USE pbl_surface_mod, ONLY: pbl_surface_init
     USE fonte_neige_mod, ONLY: fonte_neige_init
     USE phys_state_var_mod
-    USE control_mod, ONLY: dayref, nday, iphysiq
+    USE time_phylmdz_mod, ONLY: day_ref, ndays, pdtphys, &
+                                day_ini,day_end
     USE indice_sol_mod
-
+    USE nrtype, ONLY: pi
     USE ioipsl
     IMPLICIT NONE
 
-    include "dimensions.h"
-    ! #include "dimphy.h"
-    ! #include "YOMCST.h"
-    include "comconst.h"
+    include "YOMCST.h"
     include "clesphys.h"
     include "dimsoil.h"
-    include "temps.h"
 
     INTEGER, INTENT (IN) :: nlon, iflag_phys
     ! IM ajout latfi, lonfi
-    REAL, INTENT (IN) :: lonfi(nlon), latfi(nlon)
+!    REAL, INTENT (IN) :: lonfi(nlon), latfi(nlon)
 
     INTEGER type_profil, type_aqua
@@ -120,8 +117,8 @@
     INTEGER l, ierr, aslun
 
-    REAL longitude, latitude
+!    REAL longitude, latitude
     REAL paire
 
-    DATA latitude, longitude/48., 0./
+!    DATA latitude, longitude/48., 0./
 
     ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -152,8 +149,8 @@
 
     ! IM ajout latfi, lonfi
-    rlatd = latfi
-    rlond = lonfi
-    rlat = rlatd*180./pi
-    rlon = rlond*180./pi
+!    rlatd = latfi
+!    rlond = lonfi
+!    rlat = rlatd*180./pi
+!    rlon = rlond*180./pi
 
     ! -----------------------------------------------------------------------
@@ -161,9 +158,9 @@
     ! -----------------------------------------------------------------------
 
-    day_ini = dayref
-    day_end = day_ini + nday
-    airefi = 1.
-    zcufi = 1.
-    zcvfi = 1.
+    day_ini = day_ref
+    day_end = day_ini + ndays
+!    airefi = 1.
+!    zcufi = 1.
+!    zcvfi = 1.
     !$OMP MASTER
     nbapp_rad_omp = 24
@@ -263,5 +260,5 @@
     END DO
     ! IM calcul profil sst
-    CALL profil_sst(nlon, rlatd, type_profil, phy_sst)
+    CALL profil_sst(nlon, latitude, type_profil, phy_sst)
 
     CALL writelim(klon, phy_nat, phy_alb, phy_sst, phy_bil, phy_rug, phy_ice, &
@@ -276,6 +273,6 @@
     ! Ecriture etat initial physique
 
-    timestep = dtvr*float(iphysiq)
-    radpas = nint(daysec/timestep/float(nbapp_rad))
+    timestep = pdtphys
+    radpas = nint(rday/timestep/float(nbapp_rad))
 
     DO i = 1, longcles
@@ -492,6 +489,4 @@
     USE mod_phys_lmdz_transfert_para, ONLY: gather
     IMPLICIT NONE
-    ! #include "dimensions.h"
-    ! #include "dimphy.h"
     include "netcdf.inc"
 
Index: /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2408)
@@ -11,5 +11,5 @@
   USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, dtime, &
        qsol, fevap, z0m, z0h, agesno, &
-       du_gwd_rando, dv_gwd_rando, entr_therm, f0, fm_therm, &
+       du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
        falb_dir, falb_dif, &
        ftsol, pbl_tke, pctsrf, q_ancien, radpas, radsol, rain_fall, ratqs, &
@@ -21,9 +21,10 @@
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl
   USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
-  USE infotrac, only: nbtr, nqo, type_trac, tname, niadv
+  USE infotrac_phy, only: nbtr, nqo, type_trac, tname, niadv
   USE traclmdz_mod,    ONLY : traclmdz_from_restart
   USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
   USE indice_sol_mod, only: nbsrf, is_ter, epsfra, is_lic, is_oce, is_sic
   USE ocean_slab_mod, ONLY: tslab, seaice, tice, ocean_slab_init
+  USE time_phylmdz_mod, ONLY: init_iteration, pdtphys, itau_phy
 
   IMPLICIT none
@@ -32,9 +33,7 @@
   ! Objet: Lecture de l'etat initial pour la physique
   !======================================================================
-  include "dimensions.h"
   include "netcdf.inc"
   include "dimsoil.h"
   include "clesphys.h"
-  include "temps.h"
   include "thermcell.h"
   include "compbl.h"
@@ -75,5 +74,5 @@
   ! FH1D
   !     real iolat(jjm+1)
-  real iolat(jjm+1-1/(iim*jjm))
+  !real iolat(jjm+1-1/(iim*jjm))
 
   ! Ouvrir le fichier contenant l'etat initial:
@@ -100,5 +99,5 @@
   ENDDO
 
-  tab_cntrl(1)=dtime
+  tab_cntrl(1)=pdtphys
   tab_cntrl(2)=radpas
 
@@ -134,4 +133,7 @@
   clesphy0(7)=tab_cntrl( 11 )
   clesphy0(8)=tab_cntrl( 12 )
+
+  ! set time iteration
+   CALL init_iteration(itau_phy)
 
   ! Lecture des latitudes (coordonnees):
@@ -223,5 +225,5 @@
         IF (isw.GT.99) THEN
            PRINT*, "Trop de bandes SW"
-           call abort_gcm("phyetat0", "", 1)
+           call abort_physic("phyetat0", "", 1)
         ENDIF
         WRITE(str2, '(i2.2)') isw
@@ -238,5 +240,5 @@
         IF (isoil.GT.99) THEN
            PRINT*, "Trop de couches "
-           call abort_gcm("phyetat0", "", 1)
+           call abort_physic("phyetat0", "", 1)
         ENDIF
         WRITE(str2,'(i2.2)') isoil
@@ -359,5 +361,5 @@
      IF (carbon_cycle_cpl) THEN
         ALLOCATE(co2_send(klon), stat=ierr)
-        IF (ierr /= 0) CALL abort_gcm('phyetat0', 'pb allocation co2_send', 1)
+        IF (ierr /= 0) CALL abort_physic('phyetat0', 'pb allocation co2_send', 1)
         found=phyetat0_get(1,co2_send,"co2_send","co2 send",0.)
      END IF
@@ -369,8 +371,8 @@
 
 !  ondes de gravite non orographiques
-  if (ok_gwd_rando) then
-     found=phyetat0_get(klev,du_gwd_rando,"du_gwd_rando","du_gwd_rando",0.)
-     found=phyetat0_get(klev,dv_gwd_rando,"dv_gwd_rando","dv_gwd_rando",0.)
-  end if
+  if (ok_gwd_rando) found = &
+       phyetat0_get(klev,du_gwd_rando,"du_gwd_rando","du_gwd_rando",0.)
+  IF (.not. ok_hines .and. ok_gwd_rando) found &
+       = phyetat0_get(klev,du_gwd_front,"du_gwd_front","du_gwd_front",0.)
 
 !  prise en compte du relief sous-maille
@@ -449,7 +451,7 @@
 USE iostart, ONLY : get_field
 USE dimphy, only: klon 
+USE print_control_mod, ONLY: lunout
 
 IMPLICIT NONE
-INCLUDE "iniprint.h"
 
 LOGICAL phyetat0_get
@@ -488,7 +490,7 @@
 USE dimphy, only: klon 
 USE indice_sol_mod, only: nbsrf
+USE print_control_mod, ONLY: lunout
 
 IMPLICIT NONE
-INCLUDE "iniprint.h"
 
 LOGICAL phyetat0_srf
@@ -506,5 +508,5 @@
      IF (nbsrf.GT.99) THEN
         WRITE(lunout,*) "Trop de sous-mailles"
-        call abort_gcm("phyetat0", "", 1)
+        call abort_physic("phyetat0", "", 1)
      ENDIF
 
Index: /LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2408)
@@ -1,30 +1,37 @@
-! $Id$
-
 SUBROUTINE phyredem (fichnom)
-
-  USE dimphy
-  USE mod_grid_phy_lmdz
-  USE mod_phys_lmdz_para
+!
+!-------------------------------------------------------------------------------
+! Author: Z.X. Li (LMD/CNRS), 1993/08/18
+!-------------------------------------------------------------------------------
+! Purpose: Write restart state for physics.
+!-------------------------------------------------------------------------------
+  USE dimphy, ONLY: klon, klev
   USE fonte_neige_mod,  ONLY : fonte_neige_final
   USE pbl_surface_mod,  ONLY : pbl_surface_final
-  USE phys_state_var_mod
-  USE iostart
+  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf, ftsol, falb_dir, &
+                                falb_dif, qsol, fevap, radsol, solsw, sollw, &
+                                sollwdown, rain_fall, snow_fall, z0m, z0h, &
+                                agesno, zmea, zstd, zsig, zgam, zthe, zpic, &
+                                zval, rugoro, t_ancien, q_ancien, u_ancien, &
+                                v_ancien, clwcon, rnebcon, ratqs, pbl_tke, &
+                                wake_delta_pbl_tke, zmax0, f0, sig1, w01, &
+                                wake_deltat, wake_deltaq, wake_s, wake_cstar, &
+                                wake_pe, wake_fip, fm_therm, entr_therm, &
+                                detr_therm, Ale_bl, Ale_bl_trig, Alp_bl, &
+                                du_gwd_rando, du_gwd_front
+  USE geometry_mod, ONLY : longitude_deg, latitude_deg
+  USE iostart, ONLY: open_restartphy, close_restartphy, put_field, put_var
   USE traclmdz_mod, ONLY : traclmdz_to_restart
-  USE infotrac
-  USE control_mod
+  USE infotrac_phy, ONLY: type_trac, niadv, tname, nbtr, nqo
   USE carbon_cycle_mod, ONLY : carbon_cycle_cpl, co2_send
-  USE indice_sol_mod
-  USE surface_data
+  USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic, epsfra
+  USE surface_data, ONLY: type_ocean, version_ocean
   USE ocean_slab_mod, ONLY : tslab, seaice, tice, fsic
+  USE time_phylmdz_mod, ONLY: annee_ref, day_end, itau_phy, pdtphys
 
   IMPLICIT none
-  !======================================================================
-  ! Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
-  ! Objet: Ecriture de l'etat de redemarrage pour la physique
-  !======================================================================
-  include "netcdf.inc"
+
   include "dimsoil.h"
   include "clesphys.h"
-  include "temps.h"
   include "thermcell.h"
   include "compbl.h"
@@ -49,5 +56,5 @@
   INTEGER isoil, nsrf,isw
   CHARACTER (len=7) :: str7
-  CHARACTER (len=2) :: str2
+  CHARACTER (len=256) :: nam, lnam
   INTEGER           :: it, iiq
 
@@ -68,5 +75,5 @@
      tab_cntrl(ierr) = 0.0
   ENDDO
-  tab_cntrl(1) = dtime
+  tab_cntrl(1) = pdtphys
   tab_cntrl(2) = radpas
   ! co2_ppm : current value of atmospheric CO2
@@ -92,7 +99,7 @@
 
   CALL put_field("longitude", &
-       "Longitudes de la grille physique", rlon)
-
-  CALL put_field("latitude", "Latitudes de la grille physique", rlat)
+       "Longitudes de la grille physique", longitude_deg)
+
+  CALL put_field("latitude", "Latitudes de la grille physique", latitude_deg)
 
   ! PB ajout du masque terre/mer
@@ -126,81 +133,31 @@
   CALL put_field("FSIC", "fraction glace mer", pctsrf(:, is_sic))
 
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("TS"//str2, "Temperature de surface No."//str2, &
-             ftsol(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
+  IF(nbsrf>99) THEN
+    PRINT*, "Trop de sous-mailles";  CALL abort_physic("phyredem", "", 1)
+  END IF
+  IF(nsoilmx>99) THEN
+    PRINT*, "Trop de sous-surfaces"; CALL abort_physic("phyredem", "", 1)
+  END IF
+  IF(nsw>99) THEN
+    PRINT*, "Trop de bandes"; CALL abort_physic("phyredem", "", 1)
+  END IF
+
+  CALL put_field_srf1("TS","Temperature",ftsol(:,:))
 
 ! ================== Albedo =======================================
   print*,'PHYREDEM NOUVEAU'
-  DO nsrf = 1, nbsrf
-     DO isw=1, nsw
-        IF (isw.LE.99 .AND. nsrf.LE.99) THEN
-           WRITE(str7, '(i2.2, "srf", i2.2)') isw, nsrf
-  print*,'PHYREDEM ',"A_dir_SW"//str7
-           CALL put_field("A_dir_SW"//str7, "Albedo direct du sol bande "//str7, &
-                falb_dir(:, isw, nsrf))
-           CALL put_field("A_dif_SW"//str7, "Albedo difus du sol bande "//str7, &
-                falb_dif(:, isw, nsrf))
-        ELSE
-           PRINT*, "Trop de couches"
-           call abort_gcm("phyredem", "", 1)
-        ENDIF
-     ENDDO
-  ENDDO
-
-! ================== Tsoil =======================================
-  DO nsrf = 1, nbsrf
-     DO isoil=1, nsoilmx
-        IF (isoil.LE.99 .AND. nsrf.LE.99) THEN
-           WRITE(str7, '(i2.2, "srf", i2.2)') isoil, nsrf
-           CALL put_field("Tsoil"//str7, "Temperature du sol No."//str7, &
-                tsoil(:, isoil, nsrf))
-        ELSE
-           PRINT*, "Trop de couches"
-           call abort_gcm("phyredem", "", 1)
-        ENDIF
-     ENDDO
-  ENDDO
-
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("QS"//str2, "Humidite de surface No."//str2, &
-             qsurf(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  END DO
-
-  CALL put_field("QSOL", "Eau dans le sol (mm)", qsol)
-
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("EVAP"//str2, "Evaporation de surface No."//str2 &
-             , fevap(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
-
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("SNOW"//str2, "Neige de surface No."//str2, &
-             snow(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
+  CALL put_field_srf2("A_dir_SW","Albedo direct",falb_dir(:,:,:))
+  CALL put_field_srf2("A_dif_SW","Albedo diffus",falb_dif(:,:,:))
+
+! ================== Tsoil =========================================
+  CALL put_field_srf2("Tsoil","Temperature",tsoil(:,:,:))
+
+  CALL put_field_srf1("QS"  , "Humidite",qsurf(:,:))
+
+  CALL put_field     ("QSOL", "Eau dans le sol (mm)", qsol)
+
+  CALL put_field_srf1("EVAP", "Evaporation", fevap(:,:))
+
+  CALL put_field_srf1("SNOW", "Neige", snow(:,:))
 
   CALL put_field("RADS", "Rayonnement net a la surface", radsol)
@@ -210,5 +167,5 @@
   CALL put_field("sollw", "Rayonnement IF a la surface", sollw)
 
-  CALL put_field("sollwdown", "Rayonnement down IF a la surface", sollw)
+  CALL put_field("sollwdown", "Rayonnement down IF a la surface", sollwdown)
 
   CALL put_field("fder", "Derive de flux", fder)
@@ -218,28 +175,9 @@
   CALL put_field("snow_f", "precipitation solide", snow_fall)
 
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("Z0m"//str2, "rugosite de surface No."//str2, &
-             z0m(:, nsrf))
-        CALL put_field("Z0h"//str2, "rugosite de surface No."//str2, &
-             z0h(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
-
-  DO nsrf = 1, nbsrf
-     IF (nsrf.LE.99) THEN
-        WRITE(str2, '(i2.2)') nsrf
-        CALL put_field("AGESNO"//str2, &
-             "Age de la neige surface No."//str2, &
-             agesno(:, nsrf))
-     ELSE
-        PRINT*, "Trop de sous-mailles"
-        call abort_gcm("phyredem", "", 1)
-     ENDIF
-  ENDDO
+  CALL put_field_srf1("Z0m", "rugosite", z0m(:,:))
+
+  CALL put_field_srf1("Z0h", "rugosite", z0h(:,:))
+
+  CALL put_field_srf1("AGESNO", "Age de la neige", agesno(:,:))
 
   CALL put_field("ZMEA", "ZMEA", zmea)
@@ -280,17 +218,9 @@
 
   IF (iflag_pbl>1) then
-     DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-           WRITE(str2, '(i2.2)') nsrf
-           CALL put_field("TKE"//str2, "Energ. Cineti. Turb."//str2, &
-                pbl_tke(:, 1:klev+1, nsrf))
-           CALL put_field("DELTATKE"//str2, "Del TKE wk/env."//str2, &
-                wake_delta_pbl_tke(:, 1:klev+1, nsrf))
-        ELSE
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyredem", "", 1)
-        ENDIF
-     ENDDO
-  ENDIF
+    CALL put_field_srf3("TKE", "Energ. Cineti. Turb.", &
+         pbl_tke(:,:,:))
+    CALL put_field_srf3("DELTATKE", "Del TKE wk/env.", &
+         wake_delta_pbl_tke(:,:,:))
+  END IF
 
   ! FIN TKE PBL !
@@ -360,15 +290,67 @@
   END IF
 
-  if (ok_gwd_rando) then
-     call put_field("du_gwd_rando", &
-          "tendency on zonal wind due to gravity waves", &
-          du_gwd_rando)
-     call put_field("dv_gwd_rando", &
-          "tendency on meriodional wind due to gravity waves", &
-          dv_gwd_rando)
-  end if
+  if (ok_gwd_rando) call put_field("du_gwd_rando", &
+       "tendency on zonal wind due to flott gravity waves", du_gwd_rando)
+
+  IF (.not. ok_hines .and. ok_gwd_rando) call put_field("du_gwd_front", &
+       "tendency on zonal wind due to acama gravity waves", du_gwd_front)
 
   CALL close_restartphy
   !$OMP BARRIER
 
+
+  CONTAINS
+
+
+SUBROUTINE put_field_srf1(nam,lnam,field)
+
+  IMPLICIT NONE
+  CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
+  REAL,              INTENT(IN) :: field(:,:)
+  CHARACTER(LEN=256) :: nm, lm, str
+  DO nsrf = 1, SIZE(field,2)
+    WRITE(str, '(i2.2)') nsrf
+    nm=TRIM(nam)//TRIM(str)
+    lm=TRIM(lnam)//" de surface No. "//TRIM(str)
+    CALL put_field(nm,lm,field(:,nsrf))
+  END DO
+
+END SUBROUTINE put_field_srf1
+
+
+SUBROUTINE put_field_srf2(nam,lnam,field)
+
+  IMPLICIT NONE
+  CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
+  REAL,              INTENT(IN) :: field(:,:,:)
+  CHARACTER(LEN=256) :: nm, lm, str
+  DO nsrf = 1, SIZE(field,3)
+    DO isoil=1, SIZE(field,2)
+      WRITE(str, '(i2.2,"srf",i2.2)')isoil,nsrf
+!      WRITE(lunout,*)"PHYREDEM ",TRIM(nam)//TRIM(str)
+      nm=TRIM(nam)//TRIM(str)
+      lm=TRIM(lnam)//" du sol No. "//TRIM(str)
+      CALL put_field(nm,lm,field(:,isoil,nsrf))
+    END DO
+  END DO
+
+END SUBROUTINE put_field_srf2
+
+
+SUBROUTINE put_field_srf3(nam,lnam,field)
+
+  IMPLICIT NONE
+  CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
+  REAL,              INTENT(IN) :: field(:,:,:)
+  CHARACTER(LEN=256) :: nm, lm, str
+  DO nsrf = 1, SIZE(field,3)
+    WRITE(str, '(i2.2)') nsrf
+    nm=TRIM(nam)//TRIM(str)
+    lm=TRIM(lnam)//TRIM(str)
+    CALL put_field(nm,lm,field(:,1:klev+1,nsrf))
+  END DO
+
+END SUBROUTINE put_field_srf3
+
+
 END SUBROUTINE phyredem
